<template>
    <div>
        <div class="card">
            <div class="card-header border-bottom">
                <div class="d-flex align-items-center">
                    <h5 class="card-header-title">Two-step verification</h5>
                    <span class="badge bg-soft-danger text-danger ms-2">Disabled</span>
                </div>
            </div>
            <!-- Body -->
            <div class="card-body">
                <div class="row mt-4 mb-4">
                    <div class="col-12 mb-3">
                        <!-- Button trigger modal -->
                        <button type="button" class="btn btn-primary float-lg-end" data-bs-toggle="modal"
                                data-bs-target="#exampleModal">
                            <i class="bi bi-plus-circle"></i> Crear post
                        </button>
                        <!-- Modal -->
                    </div>
                    <div class="col-12 mt-4">
                        <input type="text" v-model="search" class="form-control" placeholder="Ingrese el título, contenido ó nombre del author para realizar la búsqueda">
                    </div>
                    <div class="col-3">
                        <div class="modal fade" ref="mimodal"   v-show="modalVisible" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel"
                             aria-hidden="true">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="exampleModalLabel">Crear post</h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal"
                                                aria-label="Close"></button>
                                    </div>
                                    <div class="modal-body">
                                        <create></create>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" @click="cerrarModal">Close
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <ul class="list-unstyled mb-5">
                    <!-- Card -->
                    <li v-for="item in items" :key="item.id" class="card card-bordered shadow-none mb-3">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-6 col-md mb-3 mb-md-0">
                                    <small class="card-subtitle mb-0">Título</small>
                                    <small class="text-dark fw-semibold">{{ item.title }}</small>
                                </div>
                                <!-- End Col -->

                                <div class="col-6 col-md mb-3 mb-md-0">
                                    <small class="card-subtitle mb-0">Autor</small>
                                    <small class="text-dark fw-semibold">{{ item.author }}</small>
                                </div>
                                <!-- End Col -->

                                <div class="col-6 col-md">
                                    <small class="card-subtitle mb-0">Fecha publicación.</small>
                                    <small class="text-dark fw-semibold">{{ item.publication_date }}</small>
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <div class="col-md-8">
                                    <h5>{{ item.content.slice(0, 70)  }}...</h5>

                                    <div class="row gx-2">

                                    </div>
                                    <!-- End Row -->
                                </div>
                                <div class="col-md-4">
                                    <div class="d-grid gap-2">
                                        <button class="btn btn-primary" @click="abrirDetalle(item)"><i class="bi bi-eye"></i> Abrir detalle</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </li>
                </ul>
                <router-view ></router-view>
            </div>
            <!-- End Body -->
        </div>
    </div>
</template>
<script>
import axios from 'axios';
import Create from './Create.vue'
import Show from './Show.vue'
import $ from 'jquery';

export default {
    components: {
        Create,
        Show
    },
    data() {
        return {
            items: [],
            modalVisible: false,
            search:null
        };
    },
    watch: {
        search: function (newSearch, oldSearch) {
            if (newSearch !== oldSearch) {
                this.axiosData();
            }
        },
    },
    mounted() {
        this.axiosData();
    },
    methods: {
        async axiosData() {
            try {
                const response = await axios.get('api/v1/posts', {
                    params: {
                        search: this.search,
                    },
                });
                if (response && response.data) {
                    this.items = response.data.data;
                }
            } catch (error) {
                swal.fire({
                    icon: 'error',
                    title: 'Error',
                    text: 'Error al procesar la solicitud.',
                });
            }
        },
        actualizarListado() {
            this.cerrarModal();
            this.axiosData();
        },
        cerrarModal() {
            this.modalVisible = false;
        },
        abrirDetalle(item) {
            this.$router.push({ name: 'Detail', params: { id: item.id } });
        },
    },
};
</script>
